<?php

/** 
 * @version		1.5.0
 * @package		muscol
 * @copyright	2009 JoomlaMusicSolutions.com
 * @license		GPLv2
 */
jimport( 'joomla.application.component.view');
jimport( 'joomla.plugin.helper');
require_once(JPATH_COMPONENT.DS.'helpers'.DS.'helpers.php');
//jomcomment integration
if(file_exists(JPATH_PLUGINS . DS . 'content' . DS . 'jom_comment_bot.php')) include_once( JPATH_PLUGINS . DS . 'content' . DS . 'jom_comment_bot.php' );

class ArtistsViewSong extends JView
{
	function display($tpl = null)
	{
		$mainframe =& JFactory::getApplication();
		
		$pathway	= & $mainframe->getPathway();
		$document	= & JFactory::getDocument();
		$dispatcher	=& JDispatcher::getInstance();
		$params = &JComponentHelper::getParams( 'com_muscol' );
		
		if($params->get('registersongviews')) $this->get('RegisterHit');
		
		$uri	= & JFactory::getURI();
	
		$song		= & $this->get( 'Data');
		$prev_song		= & $this->get( 'PrevSongData');
		$next_song		= & $this->get( 'NextSongData');
		$hits		= & $this->get( 'Hits');
		
		$is_rated		= & $this->get( 'RatedByThisUser');
		$average_rating		= & $this->get( 'AverageRating');
		$num_rating		= & $this->get( 'NumRating');
		
		if($params->get('showsongcomments') ){ // show the comments 
			switch($params->get('commentsystem')){ 
				
				case 'jomcomment':
					 $this->assignRef('jomcomment',	jomcomment( 200000000 + $song->id, "com_muscol"));  // 200000000 code for song comments
					 break;
				default:
					$comments		= & $this->get( 'Comments');
					$this->assignRef('comments',		$comments);
				break;
			}
		}
		
		if(JRequest::getVar('layout') != "form"){
			
			$plugins = JPluginHelper::getPlugin('muscolplayers');
			$plugin = $plugins[0];
			// we use only one player, the first in the plugin item list
			$plugin_ok = JPluginHelper::importPlugin('muscolplayers',$plugin->name); 
			
			if( ($song->filename != "" || $song->video != "") && $plugin_ok){
				$player = plgMuscolplayers::renderPlayer($song, false, array("force_show_player" => true));
				
				//new for song playing count statistics
				$js_songs[] = "songs_position_id[0] = ".$song->id.";";
				//new for HTML5 player
				$js_songs_url[] = "songs_position_url[0] = \"".MusColHelper::getSongFileURL($song)."\";" ;
				if(count($js_songs)) $document->addScriptDeclaration( "var songs_position_id = new Array(); ".implode(" ",$js_songs) );
				if(count($js_songs_url)) $document->addScriptDeclaration( "var songs_position_url = new Array(); ".implode(" ",$js_songs_url) );
				
			}
			else $player = "";
		
		}

		$this->assignRef('song',		$song);
		$this->assignRef('prev_song',		$prev_song);
		$this->assignRef('next_song',		$next_song);
		$this->assignRef('player',		$player);
		$this->assignRef('params',		$params);
		$this->assignRef('hits',		$hits);
		
		$this->assignRef('is_rated',		$is_rated);
		$this->assignRef('average_rating',		$average_rating);
		$this->assignRef('num_rating',		$num_rating);
		
		if($params->get('keywords') != ""){
			$document->setMetaData( 'keywords', $document->getMetaData( 'keywords' ) . ", " . $params->get('keywords') );
		}
		if($params->get('description') != ""){
			$document->setMetaData( 'description', $params->get('description') );
		}
		
		if(JRequest::getVar('layout') == "form"){
			$artists		=& $this->get('ArtistsData');
			$genres			=& $this->get('GenresData');
			
			$this->assignRef('artists',		$artists);
			$this->assignRef('genres',		$genres);
			
			$document->addStyleSheet( $uri->base() . 'components/com_muscol/assets/form.css');

		}
		
		//creem els breadcrumbs
		$letters = MusColAlphabets::get_combined_array();
		
		$pathway->addItem($letters[$song->letter], 'index.php?option=com_muscol&view=artists&letter='.$song->letter);
		$pathway->addItem($song->artist_name, 'index.php?option=com_muscol&view=artist&id='.$song->artist_id);
		$pathway->addItem($song->album_name, 'index.php?option=com_muscol&view=album&id='.$song->album_id);
		$pathway->addItem($song->name, 'index.php?option=com_muscol&view=song&id='.$song->id);
		
		//creem el titol
		
		$document->setTitle( $song->name ." - ". $song->artist_name);
		
		//cridem els JavaScript
		$document->addScriptDeclaration('var star_icon_path = "'.JURI::root(true).'/components/com_muscol/assets/images/";');
		$document->addScript( $uri->base() . 'components/com_muscol/assets/stars.js');
		
		//cridem els CSS
		$document->addStyleSheet( $uri->base() . 'components/com_muscol/assets/letter.css');
		$document->addStyleSheet( $uri->base() . 'components/com_muscol/assets/song.css');
		$document->addStyleSheet( $uri->base() . 'components/com_muscol/assets/comments.css');
		
		parent::display($tpl);
	}
}
?>
