<?php
/*
 * @package Joomla 1.5
 * @copyright Copyright (C) 2005 Open Source Matters. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 *
 * @component XMovie Component
 * @copyright Copyright (C) Dana Harris optikool.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */
defined('_JEXEC') or die('Restricted access');
jimport('joomla.application.component.view');
	
JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_xmovie'.DS.'tables');
	
class XMovieViewCategory extends JView {
	function display($tpl = null) {
		global $mainframe;
		
		$component = JComponentHelper::getComponent( 'com_xmovie' );
  		$cfgParams = new JParameter( $component->params );
  		$params =& $mainframe->getParams();
  		$compId = MovieHelper::getComponentId();
		$pathway =& $mainframe->getPathway();
		$items   = $pathway->getPathWay();

		$itemsCount = count($items) - 1;
		$headingName = $items[$itemsCount]->name;	

		$movies =& $this->get('data');
		$subCategories = $this->get('subCategories');

		$pagitems =& $this->get('pagination');	
		
		$div_width = intval(100 / intval($params->get('single_cat_mov_per_row', $cfgParams->get('cview_cat_mov_per_row', 4))));
		$resizeThumbnails = $cfgParams->get('resize_thumbs', 1);
		
		$thumbPath = $cfgParams->get('movie_thumb_path', 'images/stories');

		$browser = MovieHelper::getBrowserType();
		if($browser['browser'] == 'IE') {
			$div_width = $div_width - 1;
		}
		
		$categoryInfo = $this->get('CategoryInfo');
						
		$user =& JFactory::getUser();
		$display_layout_cat = $params->get('single_cat_display_view', $cfgParams->get('cview_display_view', 'cat_list'));
		$display_layout = $params->get('single_cat_display_mov', $cfgParams->get('cview_display_mov_view', 'list'));
		$document = &JFactory::getDocument();
		
		if($display_layout_cat == 'cat_column' || $display_layout == 'column') {
			$d_layout = 'column';
			$document->addStyleSheet(JURI::base(true).'/components/com_xmovie/css/'.$d_layout.'-style.css');
		}
		
		if($display_layout_cat == 'cat_list' || $display_layout == 'list') {
			$d_layout = 'list';			
			$document->addStyleSheet(JURI::base(true).'/components/com_xmovie/css/'.$d_layout.'-style.css');
		}
		
		$mydoc =& JFactory::getDocument();
		$mytitle = $mydoc->getTitle();

		$conf =& JFactory::getConfig();

		$mydoc->setTitle($mytitle.' - '.$categoryInfo->name);
		
		if($cfgParams->get('enable_rss', 0)) {
			$feed =  JURI::root()."index.php?option=com_xmovie&controller=feed&view=rss&id={$categoryInfo->id}&Itemid={$compId->id}&format=feed";
			$rss = array(
						'type' 	=>  'application/rss+xml',
						'title'	=>	'RSS 1.0');
		
			$atom = array(
						'type' 	=>  'application/atom+xml',
						'title'	=>	'Atom');
				
			$document->addHeadLink(JRoute::_($feed.'&type=rss'), 'alternate', 'rel', $rss);
			$document->addHeadLink(JRoute::_($feed.'&type=atom'), 'alternate', 'rel', $atom);
			$this->assign('enable_rss', $cfgParams->get('enable_rss'));
			
		} else {
			$this->assign('enable_rss', $cfgParams->get('enable_rss'));
		}

		// HTML Parameters
		$this->assignRef('subCategories', $subCategories);
		$this->assignRef('categoryInfo', $categoryInfo);
		$this->assignRef('movies', $movies);
		$this->assignRef('pagination', $pagitems);
		$this->assignRef('div_width', $div_width);
		$this->assignRef('params', $params);
		$this->assignRef('num_thumb', $params->get('single_cat_mov_per_row', $cfgParams->get('cview_cat_mov_per_row', 4)));
		$this->assignRef('num_thumb_cat', $params->get('single_mov_per_row', $cfgParams->get('cview_mov_per_row', 4)));
		$this->assignRef('compid', $compId->id);
		$this->assign('display_layout', $display_layout);
		$this->assign('display_layout_cat', $display_layout_cat);

		// Category Parameters 
		$this->assign('show_cat_description', (bool)$params->get('single_show_cat_description', $cfgParams->get('cview_show_cat_description', 1)));
		$this->assign('show_main_title', (bool)$params->get('single_cat_show_main_title', $cfgParams->get('cview_show_main_title', 1)));
		$this->assign('show_subcat', (bool)$params->get('single_cat_show_subcat', $cfgParams->get('cview_show_subcat', 1)));
		$this->assign('show_cat_title', (bool)$params->get('single_cat_show_subcat_title', $cfgParams->get('cview_show_cat_title', 1)));
		$this->assign('cat_show_thumb', (bool)$params->get('single_cat_show_thumb', $cfgParams->get('cview_cat_show_thumb', 1)));
		$this->assign('cat_show_name', (bool)$params->get('single_cat_show_name', $cfgParams->get('cview_cat_show_name', 1)));
		$this->assign('cat_show_date', (bool)$params->get('single_cat_show_date', $cfgParams->get('cview_cat_show_date', 1)));
		$this->assign('cat_show_hits', (bool)$params->get('single_cat_show_hits', $cfgParams->get('cview_cat_show_hits', 1)));
		$this->assign('show_quicktake_cat', (bool)$params->get('single_cat_show_quicktake', $cfgParams->get('cview_cat_show_quicktake', 1)));
		$this->assign('cview_cat_width', $params->get('cview_cat_width', '75'));
		$this->assign('cview_cat_height', $params->get('cview_cat_height', '75'));
		
		// Movie Parameters
		$this->assign('show_movie_heading', (bool)$params->get('single_cat_show_mov_heading', $cfgParams->get('cview_show_movie_heading', 1)));
		$this->assign('show_thumb', (bool)$params->get('single_cat_show_mov_thumb', $cfgParams->get('cview_show_c_thumb', 1)));
		$this->assign('show_name', (bool)$params->get('single_cat_show_mov_name', $cfgParams->get('cview_show_c_name', 1)));
		$this->assign('show_date', (bool)$params->get('single_cat_show_mov_date', $cfgParams->get('cview_show_c_date', 1)));
		$this->assign('show_hits', (bool)$params->get('single_cat_show_mov_hits', $cfgParams->get('cview_show_c_hits', 1)));
		$this->assign('show_submitter', (bool) $params->get('single_cat_show_mov_submitter', $cfgParams->get('cview_show_c_submitter', 1)));
		$this->assign('show_quicktake', (bool)$params->get('single_cat_show_mov_desc', $cfgParams->get('cview_show_c_quicktake', 1)));
		$this->assign('cview_mov_width', $params->get('cview_mov_width', '75'));
		$this->assign('cview_mov_height', $params->get('cview_mov_height', '75'));
		$this->assignRef('resize_thumbs', $resizeThumbnails);
		$this->assignRef('movie_thumb_path', $thumbPath);
		
		parent::display($tpl);
	}
}