<?php
/*
 * @package Joomla 1.5
 * @copyright Copyright (C) 2005 Open Source Matters. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 *
 * @component XMovie Component
 * @copyright Copyright (C) Dana Harris optikool.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */
defined('_JEXEC') or die('Restricted access');
jimport('joomla.application.component.view');
	
JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_xmovie'.DS.'tables');
	
class XMovieViewMain extends JView {
	function display($tpl = null) {
		global $mainframe;
		$pathway =& $mainframe->getPathway();
		$items   = $pathway->getPathWay();
		$itemsCount = count($items) - 1;
		$headingName = $items[$itemsCount]->name;
		
		$component = JComponentHelper::getComponent( 'com_xmovie' );
  		$cfgParams = new JParameter( $component->params );
		$params =& $mainframe->getParams();
		$compId = MovieHelper::getComponentId();
		
		$movies =& $this->get('data');
		$subCategories = $this->get('subCategories');
		$resizeThumbnails = $cfgParams->get('resize_thumbs', 1);
		$thumbPath = $cfgParams->get('movie_thumb_path', 'images/stories');

		$main =& JTable::getInstance('Category', 'Table');
		$main->load(1);
		
		if($params->get('show_main_description', 0)) {
			$maindesc = $main->description;
		} else if($params->get('show_main_quicktake', 0)) {
			$maindesc = $main->quicktake;
		} else {
			$maindesc = '';
		}
		
		$pagitems =& $this->get('pagination');
		$this->get('Breadcrumbs');
		
		$div_width = intval(100 / intval($params->get('num_thumbcol', 4)));
		$browser = MovieHelper::getBrowserType();
		if($browser['browser'] == 'IE') {
			$div_width = $div_width - 1;
		}
		
		$user =& JFactory::getUser();
		$display_layout = $params->get('display_view_main', 'column');
		$display_layout_cat = $params->get('display_view_cat', 'cat_column');
		$document = &JFactory::getDocument();
		$document->addStyleSheet(JURI::base(true).'/components/com_xmovie/css/'.$display_layout.'-style.css');
		
		if($display_layout_cat == 'cat_column' || $display_layout == 'column') {
			$d_layout = 'column';
			$document->addStyleSheet(JURI::base(true).'/components/com_xmovie/css/'.$d_layout.'-style.css');
		}
		
		if($display_layout_cat == 'cat_list' || $display_layout == 'list') {
			$d_layout = 'list';			
			$document->addStyleSheet(JURI::base(true).'/components/com_xmovie/css/'.$d_layout.'-style.css');
		}
		
		if($cfgParams->get('enable_rss', 0)) {
			$feed = JURI::root()."index.php?option=com_xmovie&controller=feed&view=rss&id=1&Itemid={$compId->id}&format=feed";
			$rss = array(
						'type' 	=>  'application/rss+xml',
						'title'	=>	'RSS 1.0');
		
			$atom = array(
						'type' 	=>  'application/atom+xml',
						'title'	=>	'Atom');
				
			$document->addHeadLink(JRoute::_($feed.'&type=rss'), 'alternate', 'rel', $rss);
			$document->addHeadLink(JRoute::_($feed.'&type=atom'), 'alternate', 'rel', $atom);
			$this->assign('enable_rss', $cfgParams->get('enable_rss'));
		} else {
			$this->assign('enable_rss', $cfgParams->get('enable_rss'));
		}
		
		// HTML Parameters
		$this->assignRef('subCategories', $subCategories);
		$this->assignRef('heading', $headingName);
		$this->assignRef('movies', $movies);
		$this->assignRef('pagination', $pagitems);
		$this->assignRef('div_width', $div_width);
		$this->assignRef('params', $params);
		$this->assignRef('num_thumb', $params->get('num_thumb', 4));
		$this->assignRef('compid', $compId->id);
		$this->assign('display_view', $display_layout);
		$this->assign('maindesc', $maindesc);
		$this->assign('mainInfo', $main);
		
		// Category Parameters 
		$this->assign('display_view_cat', $params->get('display_view_cat', 'cat_column'));
		$this->assign('show_subcat', (bool)$params->get('show_subcat', 1));
		$this->assign('show_cat_title', (bool)$params->get('show_cat_title', 1));
		$this->assign('cat_show_thumb', (bool)$params->get('cat_show_thumb', 1));
		$this->assign('cat_show_name', (bool)$params->get('cat_show_name', 1));
		$this->assign('cat_show_date', (bool)$params->get('cat_show_date', 1));
		$this->assign('cat_show_hits', (bool)$params->get('cat_show_hits', 1));
		$this->assign('main_cat_width', $params->get('main_cat_width', '75'));
		$this->assign('main_cat_height', $params->get('main_cat_height', '75'));
		$this->assign('show_quicktake_cat', (bool) $params->get('cat_show_quicktake', 0));
		
		// Movie Parameters
		$this->assign('show_movie_main', (bool) $params->get('show_movie_main', 0));
		$this->assign('show_movie_heading', (bool)$params->get('show_movie_heading', 1));
		$this->assign('show_thumb', (bool)$params->get('show_thumb', 1));
		$this->assign('show_name', (bool)$params->get('show_name', 1));
		$this->assign('show_date', (bool)$params->get('show_date', 1));
		$this->assign('show_hits', (bool)$params->get('show_hits', 1));
		$this->assign('show_submitter', (bool)$params->get('show_submitter', 1));
		$this->assign('show_description', (bool)$params->get('show_description', 1));
		$this->assign('main_mov_width', $params->get('main_mov_width', '75'));
		$this->assign('main_mov_height', $params->get('main_mov_height', '75'));
		$this->assignRef('resize_thumbs', $resizeThumbnails);
		$this->assignRef('movie_thumb_path', $thumbPath);
		
		parent::display($tpl);
	}
}