<?php
/*
 * @package Joomla 1.5
 * @copyright Copyright (C) 2005 Open Source Matters. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 *
 * @component XMovie Component
 * @copyright Copyright (C) Dana Harris optikool.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */
defined('_JEXEC') or die('Restricted access');
jimport('joomla.application.component.view');

JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_xmovie'.DS.'tables');
	
class XMovieViewSingle extends JView {
	function display($tpl = null) {
		global $mainframe;
		
		$component = JComponentHelper::getComponent( 'com_xmovie' );
  		$cfgParams = new JParameter( $component->params );
  		$params =& $mainframe->getParams();
  		$compId = MovieHelper::getComponentId();
		$movie =& $this->get('data');

		$this->get('Breadcrumbs');		
		
		$menuid = $this->get('MenuCategories');
		$menu = &JSite::getMenu();
		$active	= $menu->getActive();
		//$active->tree[] = $menuid;

		$date = JHTML::Date($movie->creation_date);
		
		$user =& JFactory::getUser($movie->submitter);
		$movie->submitter = $user->username;
		
		$display_layout = $params->get('single_display_layout', $cfgParams->get('display_layout', 'embed'));
		$resizeThumbnails = $cfgParams->get('resize_thumbs', 1);
		$thumbPath = $cfgParams->get('movie_thumb_path', 'images/stories');
		
		if($display_layout == "shadowbox") {
			$embed = MovieHelper::getShadowboxCode($movie);
		} else {
			$embed = MovieHelper::getEmbedCode($movie);
		}
		$document = &JFactory::getDocument();
		$document->addStyleSheet(JURI::base(true).'/components/com_xmovie/css/'.$display_layout.'-style.css');
		
		if($cfgParams->get('load_jquery', 0)) {
			$document->addScript(JURI::base(true).'/components/com_xmovie/js/jquery.js');
		}
		
		if($movie->type == '13' || $movie->type == '14' || $movie->type == '23' || $movie->type == '24') {
			$document->addScript(JURI::base(true).'/components/com_xmovie/js/flowplayer-3.1.4.min.js');
			$document->addStyleSheet(JURI::base(true).'/components/com_xmovie/css/flowplayer-style.css');
		}
		
		$mytitle = $document->getTitle();

		$conf =& JFactory::getConfig();

		$document->setTitle($mytitle.' - '.$movie->name);
		
		$this->assign('show_thumb', $params->get('single_show_thumb', $cfgParams->get('cview_show_thumb', 0)));
		$this->assign('show_date', $params->get('single_show_date', $cfgParams->get('cview_show_date', 0)));
		$this->assign('show_hits', $params->get('single_show_hits', $cfgParams->get('cview_show_hits', 0)));
		$this->assign('show_submitter', $params->get('single_show_submitter', $cfgParams->get('cview_show_submitter', 0)));
		$this->assign('show_description', $params->get('single_show_description', $cfgParams->get('cview_show_description', 0)));
		
		$this->assign('display_layout', $display_layout);
		$this->assignRef('movie', $movie);
		$this->assignRef('date', $date);
		$this->assignRef('embed', $embed);
		$this->assignRef('compid', $compId->id);
		$this->assignRef('resize_thumbs', $resizeThumbnails);
		$this->assignRef('movie_thumb_path', $thumbPath);

		parent::display($tpl);
	}
}